#include <starlet>
#include <descrip>
#include <iosbdef>
#include <sjcdef>
#include <lnmdef>
#include <jbcmsgdef>
#include <ssdef>
#include <string.h>

#define ARRAY_LEN(a) sizeof(a)/sizeof(a[0])
#define DSCINIT(S) { sizeof(S)-1, DSC$K_DTYPE_T, DSC$K_CLASS_S, S }

/* returns non-zero if the logical name is defined */
static int lnm$exists(char *lnm)
{
  static const struct dsc$descriptor_s lnm$tables[] = {
    DSCINIT("LNM$PROCESS"),
    DSCINIT("LNM$JOB"),
    DSCINIT("LNM$GROUP"),
    DSCINIT("LNM$SYSTEM")
  };
  struct dsc$descriptor_s lnmdsc;
  unsigned int attr = LNM$M_CASE_BLIND;
  int i, status;

  lnmdsc.dsc$w_length = strlen(lnm);
  lnmdsc.dsc$b_dtype = DSC$K_DTYPE_T;
  lnmdsc.dsc$b_class = DSC$K_CLASS_S;
  lnmdsc.dsc$a_pointer = lnm;

  for (i=0; i<ARRAY_LEN(lnm$tables); i++)
    if ((status = sys$trnlnm(&attr, &lnm$tables[i], &lnmdsc, 0, 0)) !=
        SS$_NOLOGNAM)
      break;

  return status == SS$_NORMAL;    
}

int vmsprint(char *queue, char *filespec)
{
  int status;
  iosb iostat = {0,0};
  short func = SJC$_ENTER_FILE;
  short queue_len = 0, filespec_len = 0;
  struct {
    short buf_len;
    short item_code;
    const char *buf_addr;
    short *len_addr;
  } itmlst[] = { {0, SJC$_QUEUE, queue, &queue_len},
                 {0, SJC$_FILE_SPECIFICATION, filespec, &filespec_len},
                 {0, SJC$_DELETE_FILE, 0, 0 },
                 {0, 0, 0, 0} };

  if (queue == NULL || strlen(queue) == 0) {
    if (lnm$exists("SYS$PRINT"))
      itmlst[0].buf_addr = "SYS$PRINT";
    else
      return SS$_BADPARAM;
  } 
 
  itmlst[0].buf_len = strlen( itmlst[0].buf_addr );
  itmlst[1].buf_len = strlen( itmlst[1].buf_addr );

  status = sys$sndjbcw(0,func,0,itmlst,&iostat,0,0);

  if (status == SS$_NORMAL)
    if (iostat.iosb$w_status != JBC$_NORMAL) 
      return iostat.iosb$w_status;
  
  return status;
}
